// generated by Fast Light User Interface Designer (fluid) version 1.0109

#include "dmed.h"
#include<stdlib.h>
#include<FL/Fl_file_Chooser.H>
#include"engine.h"
static int tileId; 
static char currentlevel[256]; 
static int proposed; 
static char levelComments[1024]; 

Fl_Double_Window* make_box() {
  Fl_Double_Window* w;
  { Fl_Double_Window* o = new Fl_Double_Window(104, 100);
    w = o;
    { new Fl_Box(25, 25, 25, 25, "label");
    } // Fl_Box* o
    o->end();
  } // Fl_Double_Window* o
  return w;
}
#include <FL/Fl_PNG_Image.h>
static Fl_PNG_Image *mapImage; 
#include<FL/fl_draw.h>

void Fl_Editor_Map::draw() {
  proposed=0;
draw_map();
//proposed=1;
if(proposed==1) {
int x=Fl::event_x()-this->x();
int y=Fl::event_y()-this->y();
int w=1,h=1;
struct TileProp *tileProp=tile_to_prop(tileId);

x=x/TILEWIDTH;
y=y/TILEHEIGHT;

if(tileProp) {
	w=tileProp->w;
	h=tileProp->h;
}

draw_tile_prop(tileProp,x*TILEWIDTH,y*TILEHEIGHT);
}
}

Fl_Editor_Map::Fl_Editor_Map(int x,int y,int w,int h):Fl_Box(x,y,w,h) {
}

int Fl_Editor_Map::handle(int event) {
  int state=Fl::event_state();

if(event==FL_PUSH || (event==FL_DRAG && tileId==-1) || (event==FL_DRAG && tile_to_prop(tileId) && (tile_to_prop(tileId)->type==TT_SOLIDGROUND)) || (event==FL_DRAG && tile_to_prop(tileId) && (tile_to_prop(tileId)->w==1) && (tile_to_prop(tileId)->h==1)) || (event==FL_DRAG && (state&(FL_BUTTON2|FL_BUTTON3))) ) {
	int x=Fl::event_x()-this->x();
	int y=Fl::event_y()-this->y();
	int w,h;
	struct TileProp *tileProp;
	int drawTile=tileId;
	if(state&FL_BUTTON2) drawTile=M_SOLIDGROUND;
	if(state&FL_BUTTON3) drawTile=-1;

	x=x/TILEWIDTH;
	y=y/TILEHEIGHT;

	tileProp=tile_to_prop(drawTile);
	w=1;
	h=1;
	if(tileProp) {
		printf("Setting tile %d,%d '%c'\n",x,y,tileProp->shortForm);
		w=tileProp->w;
		h=tileProp->h;
	} else {
		printf("Setting %d,%d sky\n",x,y);
	}
	save_undo(x,y,w,h,drawTile);
	set_tiles(x,y,drawTile);
	damage(FL_DAMAGE_ALL,x*TILEWIDTH,y*TILEHEIGHT,w*TILEWIDTH,h*TILEHEIGHT);
	previewMap->damage(FL_DAMAGE_ALL);
	previewMap->redraw();
	redraw();

	return 1;
}
#if 0
if(event==FL_MOVE) {
	int x=Fl::event_x()-this->x();
	int y=Fl::event_y()-this->y();
	int w,h;
	struct TileProp *tileProp;

	x=x/TILEWIDTH;
	y=y/TILEHEIGHT;

	tileProp=tile_to_prop(tile);
	w=1;
	h=1;
	if(tileProp && (tileProp->flags&8)==0) {
		printf("Setting tile %d,%d '%c'\n",x,y,tileProp->shortForm);
		w=tileProp->gfxw;
		h=tileProp->gfxh;
	} else {
		printf("Setting %d,%d sky\n",x,y);
	}
	damage(FL_DAMAGE_ALL,(x-1)*TILEWIDTH,(y-1)*TILEHEIGHT,(w+1)*TILEWIDTH,(h+1)*TILEHEIGHT);
	redraw();
	return 1;
}
#endif

return 0;
}

void Fl_Editor_Map::set_tiles(int x, int y, int tileId) {
  int i,j;
if(map.tile==NULL) return;

struct Tile *tileProp=tile_to_prop(tileId);
if(tileProp==0) tileProp=tile_to_prop(0);

for(j=0;j<tileProp->h;j++) {
	for(i=0;i<tileProp->w;i++) {
		map.tile[(x+i)+map.width*(y+j)]=tileId;
		map.map[(x+i)+map.width*(y+j)]=tileProp->x+i+TILESACROSS*(tileProp->y+j);
	}
}
}

void Fl_Preview_Map::draw() {
  int x=this->x();
int y=this->y();

if(game.width<1 || game.height<1 || mapImage==NULL) return;

uchar *buf=new uchar[game.width*game.height*3];
const char *gfxBuf=mapImage->data()[0];
int i,j;
for(j=0;j<game.height;j++) {
	for(i=0;i<game.width;i++) {
		int tile=game.map[i+game.width*j];
		int pos=(i+game.width*j);
		
		buf[pos*3]=0x88;
		buf[pos*3+1]=0xcc;
		buf[pos*3+2]=0xff;
		if(tile>-1) {
			int gfxPos=(tile%TILESACROSS)*TILEWIDTH+(tile/TILESACROSS)*TILEHEIGHT*TILEWIDTH*TILESACROSS;
			gfxPos+=TILEWIDTH/2+TILEHEIGHT/2*TILEWIDTH*TILESACROSS;
			gfxPos*=mapImage->d();
			buf[pos*3]=gfxBuf[gfxPos+0];
			buf[pos*3+1]=gfxBuf[gfxPos+1];
			buf[pos*3+2]=gfxBuf[gfxPos+2];
		}
	}
}

if(game.width<w() || game.height<h()) {
	fl_rectf(x,y,w(),h(),0,0,0);
}
fl_push_clip(x,y,w(),h());
fl_draw_image(buf,x,y,game.width,game.height);
fl_pop_clip();
delete []buf;
}

Fl_Preview_Map::Fl_Preview_Map(int x,int y,int w,int h,const char *s):Fl_Box(x,y,w,h,s) {
}
static int dirty; 

Fl_Double_Window *mainWindow=(Fl_Double_Window *)0;

Fl_Group *buttonGroup=(Fl_Group *)0;

Fl_Round_Button *rb37=(Fl_Round_Button *)0;

static void cb_rb37(Fl_Round_Button*, void*) {
  tileId=0;
}

Fl_Round_Button *rb42=(Fl_Round_Button *)0;

static void cb_rb42(Fl_Round_Button*, void*) {
  tileId=charToTile['M'];
}

static void cb_New(Fl_Menu_*, void*) {
  new_level();
}

static void cb_Open(Fl_Menu_*, void*) {
  open_level();
}

static void cb_Save(Fl_Menu_*, void*) {
  save_level();
}

static void cb_Save1(Fl_Menu_*, void*) {
  saveas_level();
}

static void cb_Quit(Fl_Menu_*, void*) {
  quit_editor();
}

static void cb_Undo(Fl_Menu_*, void*) {
  undo();
}

static void cb_Redo(Fl_Menu_*, void*) {
  redo();
}

static void cb_Quick(Fl_Menu_*, void*) {
  make_quickstart()->show();
}

static void cb_About(Fl_Menu_*, void*) {
  make_about()->show();
}

Fl_Menu_Item menu_[] = {
 {"&File", 0,  0, 0, 64, FL_NORMAL_LABEL, 0, 14, 0},
 {"&New", 0x4006e,  (Fl_Callback*)cb_New, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"&Open...", 0x4006f,  (Fl_Callback*)cb_Open, 0, 128, FL_NORMAL_LABEL, 0, 14, 0},
 {"&Save", 0x40073,  (Fl_Callback*)cb_Save, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Save &As...", 0x40061,  (Fl_Callback*)cb_Save1, 0, 128, FL_NORMAL_LABEL, 0, 14, 0},
 {"Quit", 0x40071,  (Fl_Callback*)cb_Quit, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0},
 {"&Edit", 0,  0, 0, 64, FL_NORMAL_LABEL, 0, 14, 0},
 {"Undo", 0x4007a,  (Fl_Callback*)cb_Undo, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Redo", 0x40079,  (Fl_Callback*)cb_Redo, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0},
 {"&Help", 0,  0, 0, 64, FL_NORMAL_LABEL, 0, 14, 0},
 {"&Quick Start", 0xffbe,  (Fl_Callback*)cb_Quick, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"&About", 0xffc9,  (Fl_Callback*)cb_About, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0},
 {0,0,0,0,0,0,0,0,0}
};

Fl_Counter *counterWidth=(Fl_Counter *)0;

Fl_Counter *counterHeight=(Fl_Counter *)0;

Fl_Scrollbar *verticalScroll=(Fl_Scrollbar *)0;

static void cb_verticalScroll(Fl_Scrollbar*, void*) {
  game.t=TILEHEIGHT*(int)verticalScroll->value();
editorMap->redraw();
}

Fl_Scrollbar *horizontalScroll=(Fl_Scrollbar *)0;

static void cb_horizontalScroll(Fl_Scrollbar*, void*) {
  game.l=TILEWIDTH*(int)horizontalScroll->value();
editorMap->redraw();
}

Fl_Editor_Map *editorMap=(Fl_Editor_Map *)0;

Fl_Button *comments=(Fl_Button *)0;

static void cb_comments(Fl_Button*, void*) {
  const char *s=fl_input("Comments for thie level",levelComments);
if(s) strcpy(levelComments,s);
}

Fl_Preview_Map *previewMap=(Fl_Preview_Map *)0;

int main(int argc, char **argv) {
  new_game();
if(!mapImage) mapImage=new Fl_PNG_Image("gfx.png");
  { mainWindow = new Fl_Double_Window(720, 553, "Dark Super Maro Bros Level Editor by HardHat");
    mainWindow->deactivate();
    { buttonGroup = new Fl_Group(10, 45, 710, 185, "Tile Selection");
      buttonGroup->box(FL_ROUNDED_BOX);
      buttonGroup->labeltype(FL_ENGRAVED_LABEL);
      buttonGroup->align(FL_ALIGN_TOP_LEFT);
      { rb37 = new Fl_Round_Button(650, 200, 50, 20, "Sky");
        rb37->tooltip("Sky");
        rb37->type(102);
        rb37->down_box(FL_ROUND_DOWN_BOX);
        rb37->callback((Fl_Callback*)cb_rb37);
      } // Fl_Round_Button* rb37
      { rb42 = new Fl_Round_Button(650, 180, 55, 20, "Start");
        rb42->tooltip("Start point for hero");
        rb42->type(102);
        rb42->down_box(FL_ROUND_DOWN_BOX);
        rb42->callback((Fl_Callback*)cb_rb42);
      } // Fl_Round_Button* rb42
      create_buttons(buttonGroup);
      buttonGroup->end();
    } // Fl_Group* buttonGroup
    { Fl_Menu_Bar* o = new Fl_Menu_Bar(0, 0, 720, 25);
      o->menu(menu_);
    } // Fl_Menu_Bar* o
    { counterWidth = new Fl_Counter(15, 235, 70, 25, "Width");
      counterWidth->type(1);
      counterWidth->minimum(16);
      counterWidth->maximum(1024);
      counterWidth->step(16);
      counterWidth->value(32);
    } // Fl_Counter* counterWidth
    { counterHeight = new Fl_Counter(95, 235, 70, 25, "Height");
      counterHeight->type(1);
      counterHeight->minimum(16);
      counterHeight->maximum(1024);
      counterHeight->step(16);
      counterHeight->value(16);
    } // Fl_Counter* counterHeight
    { Fl_Scrollbar* o = verticalScroll = new Fl_Scrollbar(690, 235, 25, 285);
      verticalScroll->maximum(16);
      verticalScroll->callback((Fl_Callback*)cb_verticalScroll);
      o->linesize(8);
    } // Fl_Scrollbar* verticalScroll
    { horizontalScroll = new Fl_Scrollbar(195, 525, 490, 25);
      horizontalScroll->type(1);
      horizontalScroll->callback((Fl_Callback*)cb_horizontalScroll);
    } // Fl_Scrollbar* horizontalScroll
    { Fl_Box* o = new Fl_Box(195, 235, 490, 285);
      o->box(FL_DOWN_BOX);
    } // Fl_Box* o
    { editorMap = new Fl_Editor_Map(200, 243, 480, 272);
      editorMap->box(FL_NO_BOX);
      editorMap->color(FL_BACKGROUND_COLOR);
      editorMap->selection_color(FL_BACKGROUND_COLOR);
      editorMap->labeltype(FL_NORMAL_LABEL);
      editorMap->labelfont(0);
      editorMap->labelsize(14);
      editorMap->labelcolor(FL_FOREGROUND_COLOR);
      editorMap->align(FL_ALIGN_CENTER);
      editorMap->when(FL_WHEN_RELEASE);
    } // Fl_Editor_Map* editorMap
    { comments = new Fl_Button(45, 285, 95, 30, "Comments...");
      comments->callback((Fl_Callback*)cb_comments);
    } // Fl_Button* comments
    { previewMap = new Fl_Preview_Map(5, 330, 180, 190, "overall map");
      previewMap->tooltip("Preview of the overall map");
      previewMap->box(FL_ENGRAVED_BOX);
      previewMap->color(FL_BACKGROUND_COLOR);
      previewMap->selection_color(FL_BACKGROUND_COLOR);
      previewMap->labeltype(FL_NORMAL_LABEL);
      previewMap->labelfont(0);
      previewMap->labelsize(14);
      previewMap->labelcolor(FL_FOREGROUND_COLOR);
      previewMap->align(FL_ALIGN_BOTTOM);
      previewMap->when(FL_WHEN_RELEASE);
    } // Fl_Preview_Map* previewMap
    mainWindow->end();
  } // Fl_Double_Window* mainWindow
  mainWindow->show(argc, argv);
  return Fl::run();
}

Fl_Double_Window *aboutBox=(Fl_Double_Window *)0;

static void cb_OK(Fl_Return_Button*, void*) {
  aboutBox->hide();
delete aboutBox;
aboutBox=0;
}

Fl_Double_Window* make_about() {
  { aboutBox = new Fl_Double_Window(267, 100, "About Jump Gunnar Jump Level Editor");
    { Fl_Return_Button* o = new Fl_Return_Button(155, 60, 90, 25, "OK");
      o->callback((Fl_Callback*)cb_OK);
    } // Fl_Return_Button* o
    { Fl_Output* o = new Fl_Output(25, 25, 230, 25, "Dark Super Mario Bros Level Editor by HardHat");
      o->box(FL_THIN_UP_BOX);
      o->align(FL_ALIGN_TOP_LEFT);
      o->value("Version 1.0, 2010-07-14");
    } // Fl_Output* o
    aboutBox->end();
  } // Fl_Double_Window* aboutBox
  return aboutBox;
}

Fl_Double_Window *quickstartWindow=(Fl_Double_Window *)0;

Fl_Double_Window* make_quickstart() {
  { quickstartWindow = new Fl_Double_Window(428, 309, "Quick Start for DSMB Ed");
    { Fl_Output* o = new Fl_Output(0, 5, 425, 300);
      o->type(12);
      o->value("Select new or load an existing level to start.\nThen,\nSelect a radio button up top for which sprite to draw on the map.\nUse left mouse button to draw (some sprites you need to click for each one), or use right mouse button for sky, or middle button for solid ground.\nUse undo and redo to if you are indecisive.\nEmail: hardhat@mail.ru\nhttp://www.adamcon.org/~dmwick/psp/");
    } // Fl_Output* o
    quickstartWindow->end();
  } // Fl_Double_Window* quickstartWindow
  return quickstartWindow;
}
#include<stack>
static std::stack<Undo> undoList,redoList; 

void new_level() {
  int w,h;
if(dirty) {
	if(fl_choice("Changes have been made.  Save first?","No","Yes",NULL)) {
		save_level();
	}
}
const char *s=fl_input("What width of map?","128");
w=128;
if(!s) return;
sscanf(s,"%d",&w);
if(w<0) w=32;
s=fl_input("What height of map?","128");
h=128;
if(!s) return;
sscanf(s,"%d",&h);
if(h<0) h=32;
construct_level(w,h);
resized_map();
dirty=0;
while(!undoList.empty()) undoList.pop();
while(!redoList.empty()) redoList.pop();
}

void save_level() {
  if(strlen(currentlevel)>4) {
	save_level(currentlevel);
	dirty=0;
} else {
	saveas_level();
}
}

void saveas_level() {
  char *fname=fl_file_chooser("Save As Level","*.txt",0);
if(fname) {
	strcpy(currentlevel,fname);
	save_level(fname);
}
}

void open_level() {
  char *fname=fl_file_chooser("Open Level File","*.txt",0);
if(fname) {
   editMode=1;
   load_level(fname);
   strcpy(currentlevel,fname);
}
resized_map();
dirty=0;
while(!undoList.empty()) undoList.pop();
while(!redoList.empty()) redoList.pop();
}

void quit_editor() {
  exit(1);
}

void draw_tile_prop(struct Tile *tileProp,int x,int y) {
  //if(x+TILEWIDTH+editorMap->x()<0) return;
//if(y+TILEHEIGHT+editorMap->y()<0) return;
if(x>=TILEWIDTH*SCREENWIDTH) return;
if(y>=TILEHEIGHT*SCREENHEIGHT) return;
int id=tileProp->x+tileProp->y*TILESACROSS;

printf("Drawing tile %d at %d,%d +(%d,%d)\n",id,x,y,editorMap->x(),editorMap->y());
y+=editorMap->y();
x+=editorMap->x();
if(!mapImage) mapImage=new Fl_PNG_Image("Scenery.png");
if(mapImage) {
	fl_color(proposed?0x80:0,proposed?0xff:0xc0,proposed?0x80:0xc0);
	fl_rectf(x,y,TILEWIDTH,TILEHEIGHT);
	if(id>0) mapImage->draw(x,y,TILEWIDTH,TILEHEIGHT,(id%TILESACROSS)*TILEWIDTH,(id/TILESACROSS)*TILEHEIGHT);
} else {
	fl_color((uchar)(id&1?0xff:0),(uchar)(id&2?0xff:0),(uchar)(id&4?0xff:0));
	fl_rectf(x,y,TILEWIDTH,TILEHEIGHT);
}
}

void draw_tile_rect(int id,int x,int y,int w,int h) {
}

void play_sound(int id) {
}

void resized_map() {
  counterWidth->value(game.width);
counterHeight->value(game.height);
horizontalScroll->value(game.l*TILEWIDTH,SCREENWIDTH,0,game.width*TILEWIDTH);
verticalScroll->value(game.t*TILEHEIGHT,SCREENHEIGHT,0,game.height*TILEWIDTH);
//editorMap->size(game.w*TILEWIDTH,game.h*TILEHEIGHT);
editorMap->damage(FL_DAMAGE_ALL);
previewMap->damage(FL_DAMAGE_ALL);
}

void update_button(Fl_Round_Button *button,int tileId) {
  Fl_Image *img;
struct TileProp *tileProp=tile_to_prop(tileId);
int w=1,h=1;
if(tileProp) {
	w=tileProp->w;
	h=tileProp->h;
}
if(mapImage && img) {
	unsigned char *buf=new unsigned char[w*TILEWIDTH*h*TILEHEIGHT*3];
	int x,y;
	int ox,oy;
	int i;
	int depth=mapImage->d();

	const char *rawGfx=mapImage->data()[0];
	for(i=0;i<w*TILEWIDTH*h*TILEHEIGHT*3;i++) {
		switch(i%3) {
		case 0: buf[i]=0x88; break;
		case 1: buf[i]=0xcc; break;
		case 2: buf[i]=0xff; break;
		case 3: buf[i]=0xff; break;
		}
	}
	i=0;
	int tx,ty;
	for(ty=0;ty<h;ty++) {
		for(y=0;y<TILEHEIGHT;y++) {
			for(tx=0;tx<w;tx++) {
				ox=(tileProp->x+tx)*(TILEWIDTH+1)+1;
				oy=(tileProp->y+ty)*(TILEHEIGHT+1)+1;
				for(x=0;x<TILEWIDTH;x++) {
					buf[i++]=rawGfx[((oy+y)*mapImage->w()+(ox+x))*depth];
					buf[i++]=rawGfx[((oy+y)*mapImage->w()+(ox+x))*depth+1];
					buf[i++]=rawGfx[((oy+y)*mapImage->w()+(ox+x))*depth+2];
					if(depth>3) {
						if(rawGfx[((oy+y)*TILESACROSS*TILEWIDTH+(ox+x))*depth+3]==0) {
							buf[i-3]=0x88;
							buf[i-2]=0xcc;
							buf[i-1]=0xff;
						}
					}
					if(buf[i-3]==0&& buf[i-2]==255 && buf[i-1]==0) {
							buf[i-3]=0x88;
							buf[i-2]=0xcc;
							buf[i-1]=0xff;
					}
				}
			}
		}
	}
	img=new Fl_RGB_Image(buf,w*TILEWIDTH,h*TILEHEIGHT,3);
	button->image(img);
}
}

void undo() {
  if(!undoList.empty()) {
	int i,j;
	int tileLink=undoList.top().tile;
	dirty--;

	while(undoList.size()>0 && undoList.top().tile==tileLink) {
		// We have something.
		Undo undoItem=undoList.top();
		undoList.pop();
		Undo redoItem;
		redoItem.x=undoItem.x;
		redoItem.y=undoItem.y;
		int x=redoItem.x;
		int y=redoItem.y;
		redoItem.w=undoItem.w;
		redoItem.h=undoItem.h;
		redoItem.tile=undoItem.tile;
		for(j=0;j<undoItem.h;j++) {
			for(i=0;i<undoItem.w;i++) {
				if(x+i>game.width || y+j>game.height) continue;
				redoItem.cells[j][i]=game.map[(x+i)+game.width*(y+j)];
				game.map[(x+i)+game.width*(y+j)]=undoItem.cells[j][i];
			}
		}
	
		redoList.push(redoItem);
		editorMap->damage(FL_DAMAGE_ALL,x*TILEWIDTH,y*TILEHEIGHT,undoItem.w*TILEWIDTH,undoItem.h*TILEHEIGHT);
	}
	editorMap->redraw();
	previewMap->redraw();
}
}

void redo() {
  if(!redoList.empty()) {
	int i,j;
	int tileLink=redoList.top().tile;
	dirty++;

	while(redoList.size()>0 && redoList.top().tile==tileLink) {
		// We have something.
		Undo undoItem=redoList.top();
		redoList.pop();
		Undo redoItem;
		redoItem.x=undoItem.x;
		redoItem.y=undoItem.y;
		int x=redoItem.x;
		int y=redoItem.y;
		redoItem.w=undoItem.w;
		redoItem.h=undoItem.h;
		redoItem.tile=undoItem.tile;
		for(j=0;j<undoItem.h;j++) {
			for(i=0;i<undoItem.w;i++) {
				if(x+i>game.width || y+j>game.height) continue;
				redoItem.cells[j][i]=game.map[(x+i)+game.width*(y+j)];
				game.map[(x+i)+game.width*(y+j)]=undoItem.cells[j][i];
			}
		}
	
		undoList.push(redoItem);
		editorMap->damage(FL_DAMAGE_ALL,x*TILEWIDTH,y*TILEHEIGHT,undoItem.w*TILEWIDTH,undoItem.h*TILEHEIGHT);
	}
	editorMap->redraw();
	previewMap->redraw();
}
}

void save_undo(int x,int y, int w, int h, int tile) {
  while(!redoList.empty()) redoList.pop();
dirty++;
int i,j;

Undo undoItem;
undoItem.x=x;
undoItem.y=y;
undoItem.w=w;
undoItem.h=h;
undoItem.tile=tile;
for(j=0;j<undoItem.h;j++) {
	for(i=0;i<undoItem.w;i++) {
		if(x+i>game.width || y+j>game.height) continue;
		undoItem.cells[j][i]=game.map[(x+i)+game.width*(y+j)];
	}
}
	
undoList.push(undoItem);
}

void create_buttons(Fl_Group *group) {
  int i;
int x,y,w,h;
int maxh;
int spacing=14,xpad=2,ypad=4;
int tilePropCount=tileCount;
struct Tile *tileProp=tile;
int *used=new int[tilePropCount];
int unused=tileCount;
for(i=0;i<tileCount;i++) used[i]=0;
x=spacing;
y=spacing*4;
maxh=0;
while(unused>0) {
	h=0;
	for(i=0;i<tilePropCount;i++) {
		if(used[i]==0) {
			if(tileProp[i].h*TILEHEIGHT>h) h=tileProp[i].h*TILEHEIGHT;
		}
	}
	if(h>maxh) maxh=h;
	for(i=0;i<tilePropCount;i++) {
		if(tileProp[i].h*TILEHEIGHT!=h) continue;
		used[i]=1;
		unused--;
		if(tileProp[i].name==NULL) continue;
		w=tileProp[i].w*TILEWIDTH;
		if(x+w>group->w()-spacing*2) {
			x=spacing;
			y=y+maxh+ypad;
			maxh=h;
		}
		Fl_Round_Button *o=new Fl_Round_Button(x,y,w+spacing+8,h+ypad);
		char *s=strdup(tileProp[i].name);
		unsigned int pos=0,dest=0;
		for(pos=0;pos<strlen(s);pos++) {
			if(s[pos]=='&') continue;
			s[dest++]=s[pos];
		}
		s[dest]=0;
		o->tooltip(s);
		//free(s);
		o->type(102);
		o->callback((Fl_Callback1*)select_choice,i);
		// o->image(image_fruit);
		update_button(o,i);
		x=x+w+spacing+xpad;
	}
}
delete [] used;
}

void select_choice(Fl_Widget *w,long user) {
  tileId=(int)user;
}

void draw_tile(int id,int x,int y) {
  if(x>=PTILEWIDTH*SCREENWIDTH) return;
if(y>=PTILEHEIGHT*SCREENHEIGHT) return;

//if(id>=0) printf("Drawing tile %d at %d,%d +(%d,%d)\n",id,x,y,editorMap->x(),editorMap->y());
y+=editorMap->y();
x+=editorMap->x();
if(mapImage) {
	fl_color(proposed?0x80:0,proposed?0xff:0xc0,proposed?0x80:0xc0);
	fl_rectf(x,y,PTILEWIDTH,PTILEHEIGHT);
	if(id>=0) {
		//mapImage->draw(x,y,PTILEWIDTH,PTILEHEIGHT,(id%TILESACROSS)*PTILEWIDTH,(id/TILESACROSS)*PTILEHEIGHT);
		// Draw with alpha channel.
		Fl_Image *img;
		const char *rawGfx=mapImage->data()[0];
		unsigned char *buf=new unsigned char[PTILEWIDTH*PTILEHEIGHT*3];
		int xx,yy;
		int ox,oy;
		int i;
		int depth=mapImage->d();
		int imgw=mapImage->w();

		for(i=0;i<PTILEWIDTH*PTILEHEIGHT*3;i++) {
			switch(i%3) {
			case 0: buf[i]=0x88; break;
			case 1: buf[i]=0xcc; break;
			case 2: buf[i]=0xff; break;
			case 3: buf[i]=0xff; break;
			}
		}
		i=0;
		ox=(id%TILESACROSS)*(PTILEWIDTH+1)+1;
		oy=(id/TILESACROSS)*(PTILEHEIGHT+1)+1;
		for(yy=0;yy<PTILEHEIGHT;yy++) {
			for(xx=0;xx<PTILEWIDTH;xx++) {
				buf[i++]=rawGfx[((oy+yy)*imgw+(ox+xx))*depth];
				buf[i++]=rawGfx[((oy+yy)*imgw+(ox+xx))*depth+1];
				buf[i++]=rawGfx[((oy+yy)*imgw+(ox+xx))*depth+2];
				if(depth>3) {
					unsigned char alpha=rawGfx[((oy+yy)*imgw+(ox+xx))*depth+3];
					if(alpha<255) {
						buf[i-3]=buf[i-3]*alpha/255+(255-alpha)*0x0/255;
						buf[i-2]=buf[i-2]*alpha/255+(255-alpha)*0xc0/255;
						buf[i-1]=buf[i-1]*alpha/255+(255-alpha)*0xc0/255;
					}
				}
				if(buf[i-3]==0 && buf[i-2]==255 && buf[i-3]==0) {
						buf[i-3]=0x88;
						buf[i-2]=0xcc;
						buf[i-1]=0xff;
				}
			}
		}
		img=new Fl_RGB_Image(buf,PTILEWIDTH,PTILEHEIGHT,3);
		img->draw(x,y,PTILEWIDTH,PTILEHEIGHT,0,0);
		delete img;
		delete buf;
	}
} else {
	fl_color((uchar)(id&1?0xff:0),(uchar)(id&2?0xff:0),(uchar)(id&4?0xff:0));
	fl_rectf(x,y,PTILEWIDTH,PTILEHEIGHT);
}
}
